Index: branches/stable/DNSDB.pm
===================================================================
--- branches/stable/DNSDB.pm	(revision 544)
+++ branches/stable/DNSDB.pm	(revision 545)
@@ -2517,33 +4052,57 @@
 
 
-## DNSDB::domStatus()
-# Sets and/or returns a domain's status
-# Takes a database handle, domain ID and optionally a status argument
-# Returns undef on errors.
-sub domStatus {
+## DNSDB::zoneStatus()
+# Returns and optionally sets a zone's status
+# Takes a database handle, domain/revzone ID, forward/reverse flag, and optionally a status argument
+# Returns status, or undef on errors.
+sub zoneStatus {
   my $dbh = shift;
   my $id = shift;
-  my $newstatus = shift;
+  my $revrec = shift;
+  my $newstatus = shift || 'mu';
 
   return undef if $id !~ /^\d+$/;
 
-  my $sth;
-
-# ooo, fun!  let's see what we were passed for status
-  if ($newstatus) {
-    $sth = $dbh->prepare("update domains set status=? where domain_id=?");
-    # ass-u-me caller knows what's going on in full
-    if ($newstatus =~ /^[01]$/) {	# only two valid for now.
-      $sth->execute($newstatus,$id);
-    } elsif ($newstatus =~ /^domo(?:n|ff)$/) {
-      $sth->execute(($newstatus eq 'domon' ? 1 : 0),$id);
-    }
-  }
-
-  $sth = $dbh->prepare("select status from domains where domain_id=?");
-  $sth->execute($id);
-  my ($status) = $sth->fetchrow_array;
+  # Allow transactions, and raise an exception on errors so we can catch it later.
+  # Use local to make sure these get "reset" properly on exiting this block
+  local $dbh->{AutoCommit} = 0;
+  local $dbh->{RaiseError} = 1;
+
+  if ($newstatus ne 'mu') {
+    # ooo, fun!  let's see what we were passed for status
+    eval {
+      $newstatus = 0 if $newstatus eq 'domoff';
+      $newstatus = 1 if $newstatus eq 'domon';
+      $dbh->do("UPDATE ".($revrec eq 'n' ? 'domains' : 'revzones')." SET status=? WHERE ".
+	($revrec eq 'n' ? 'domain_id' : 'rdns_id')."=?", undef, ($newstatus,$id) );
+
+##fixme  switch to more consise "Enabled <domain"/"Disabled <domain>" as with users?
+      $resultstr = "Changed ".($revrec eq 'n' ? domainName($dbh, $id) : revName($dbh, $id)).
+	" state to ".($newstatus ? 'active' : 'inactive');
+
+      my %loghash;
+      $loghash{domain_id} = $id if $revrec eq 'n';
+      $loghash{rdns_id} = $id if $revrec eq 'y';
+      $loghash{group_id} = parentID($dbh,
+	(id => $id, type => ($revrec eq 'n' ? 'domain' : 'revzone'), revrec => $revrec) );
+      $loghash{entry} = $resultstr;
+      _log($dbh, %loghash);
+
+      $dbh->commit;
+    };
+    if ($@) {
+      my $msg = $@;
+      eval { $dbh->rollback; };
+      $resultstr = '';
+      $errstr = $msg;
+      return;
+    }
+  }
+
+  my ($status) = $dbh->selectrow_array("SELECT status FROM ".
+	($revrec eq 'n' ? "domains WHERE domain_id=?" : "revzones WHERE rdns_id=?"),
+	undef, ($id) );
   return $status;
-} # end domStatus()
+} # end zoneStatus()
 
 
@@ -2561,5 +4120,5 @@
   my $dbh = shift;
   my $ifrom_in = shift;
-  my $domain = shift;
+  my $zone = shift;
   my $group = shift;
   my $status = shift;
@@ -2569,4 +4128,6 @@
   my $newttl = shift;
 
+  my $merge = shift || 0;	# do we attempt to merge A/AAAA and PTR records whenever possible?
+				# do we overload this with the fixme below?
 ##fixme:  add mode to delete&replace, merge+overwrite, merge new?
 
@@ -2577,4 +4138,8 @@
   my $ifrom;
 
+  my $rev = 'n';
+  my $code = 'OK';
+  my $msg = 'foobar?';
+
   # choke on possible bad setting in ifrom
   # IPv4 and v6, and valid hostnames!
@@ -2583,4 +4148,82 @@
 	unless ($ifrom) = ($ifrom_in =~ /^([0-9a-f\:.]+|[0-9a-z_.-]+)$/i);
 
+  my $errmsg;
+
+  my $zone_id;
+  my $domain_id = 0;
+  my $rdns_id = 0;
+  my $cidr;
+
+# magic happens!  detect if we're importing a domain or a reverse zone
+# while we're at it, figure out what the CIDR netblock is (if we got a .arpa)
+# or what the formal .arpa zone is (if we got a CIDR netblock)
+# Handles sub-octet v4 zones in the format specified in the Cricket Book, 2nd Ed, p217-218
+
+  if ($zone =~ m{(?:\.arpa\.?|/\d+)$}) {
+    # we seem to have a reverse zone
+    $rev = 'y';
+
+    if ($zone =~ /\.arpa\.?$/) {
+      # we have a formal reverse zone.  call _zone2cidr and get the CIDR block.
+      ($code,$msg) = _zone2cidr($zone);
+      return ($code, $msg) if $code eq 'FAIL';
+      $cidr = $msg;
+    } elsif ($zone =~ m|^[\d.]+/\d+$|) {
+      # v4 revzone, CIDR netblock
+      $cidr = NetAddr::IP->new($zone) or return ('FAIL',"$zone is not a valid CIDR block");
+      $zone = _ZONE($cidr, 'ZONE.in-addr.arpa', 'r', '.');
+    } elsif ($zone =~ m|^[a-fA-F\d:]+/\d+$|) {
+      # v6 revzone, CIDR netblock
+      $cidr = NetAddr::IP->new($zone) or return ('FAIL',"$zone is not a valid CIDR block");
+      return ('FAIL', "$zone is not a nibble-aligned block") if $cidr->masklen % 4 != 0;
+      $zone = _ZONE($cidr, 'ZONE.ip6.arpa', 'r', '.');
+    } else {
+      # there is. no. else!
+      return ('FAIL', "Unknown zone name format");
+    }
+
+    # quick check to start to see if we've already got one
+
+    ($zone_id) = $dbh->selectrow_array("SELECT rdns_id FROM revzones WHERE revnet=?",
+	undef, ("$cidr"));
+    $rdns_id = $zone_id;
+  } else {
+    # default to domain
+    ($zone_id) = $dbh->selectrow_array("SELECT domain_id FROM domains WHERE lower(domain) = lower(?)",
+	undef, ($zone));
+    $domain_id = $zone_id;
+  }
+
+  return ('FAIL', ($rev eq 'n' ? 'Domain' : 'Reverse zone')." already exists") if $zone_id;
+
+  # little local utility sub to swap $val and $host for revzone records.
+  sub _revswap {
+    my $rechost = shift;
+    my $recdata = shift;
+
+    if ($rechost =~ /\.in-addr\.arpa\.?$/) {
+      $rechost =~ s/\.in-addr\.arpa\.?$//;
+      $rechost = join '.', reverse split /\./, $rechost;
+    } else {
+      $rechost =~ s/\.ip6\.arpa\.?$//;
+      my @nibs = reverse split /\./, $rechost;
+      $rechost = '';
+      my $nc;
+      foreach (@nibs) {
+        $rechost.= $_;
+        $rechost .= ":" if ++$nc % 4 == 0 && $nc < 32;
+      }
+      $rechost .= ":" if $nc < 32 && $rechost !~ /\*$/;	# close netblock records?
+##fixme:  there's a case that ends up with a partial entry here:
+# ip:add:re:ss::
+# can't reproduce after letting it sit overnight after discovery.  :(
+#print "$rechost\n";
+      # canonicalize with NetAddr::IP
+      $rechost = NetAddr::IP->new($rechost)->addr unless $rechost =~ /\*$/;
+    }
+    return ($recdata,$rechost)
+  }
+
+
   # Allow transactions, and raise an exception on errors so we can catch it later.
   # Use local to make sure these get "reset" properly on exiting this block
@@ -2588,20 +4231,24 @@
   local $dbh->{RaiseError} = 1;
 
-  my $sth = $dbh->prepare("SELECT domain_id FROM domains WHERE domain=?");
-  my $dom_id;
-
-# quick check to start to see if we've already got one
-  $sth->execute($domain);
-  ($dom_id) = $sth->fetchrow_array;
-
-  return ('FAIL', "Domain already exists") if $dom_id;
-
+  my $sth;
   eval {
-    # can't do this, can't nest transactions.  sigh.
-    #my ($dcode, $dmsg) = addDomain(dbh, domain, group, status);
-
+
+    if ($rev eq 'n') {
 ##fixme:  serial
-    my $sth = $dbh->prepare("INSERT INTO domains (domain,group_id,status) VALUES (?,?,?)");
-    $sth->execute($domain,$group,$status);
+      $dbh->do("INSERT INTO domains (domain,group_id,status) VALUES (?,?,?)", undef, ($zone,$group,$status) );
+      # get domain id so we can do the records
+      ($zone_id) = $dbh->selectrow_array("SELECT currval('domains_domain_id_seq')");
+      $domain_id = $zone_id;
+      _log($dbh, (group_id => $group, domain_id => $domain_id,
+		entry => "[Added ".($status ? 'active' : 'inactive')." domain $zone via AXFR]") );
+    } else {
+##fixme:  serial
+      $dbh->do("INSERT INTO revzones (revnet,group_id,status) VALUES (?,?,?)", undef, ($cidr,$group,$status) );
+      # get revzone id so we can do the records
+      ($zone_id) = $dbh->selectrow_array("SELECT currval('revzones_rdns_id_seq')");
+      $rdns_id = $zone_id;
+      _log($dbh, (group_id => $group, rdns_id => $rdns_id,
+		entry => "[Added ".($status ? 'active' : 'inactive')." reverse zone $cidr via AXFR]") );
+    }
 
 ## bizarre DBI<->Net::DNS interaction bug:
@@ -2610,25 +4257,34 @@
 ## caused a commit instead of barfing
 
-    # get domain id so we can do the records
-    $sth = $dbh->prepare("SELECT domain_id FROM domains WHERE domain=?");
-    $sth->execute($domain);
-    ($dom_id) = $sth->fetchrow_array();
-
     my $res = Net::DNS::Resolver->new;
     $res->nameservers($ifrom);
-    $res->axfr_start($domain)
+    $res->axfr_start($zone)
 	or die "Couldn't begin AXFR\n";
 
+    $sth = $dbh->prepare("INSERT INTO records (domain_id,rdns_id,host,type,val,distance,weight,port,ttl)".
+	" VALUES (?,?,?,?,?,?,?,?,?)");
+
+    # Stash info about sub-octet v4 revzones here so we don't have
+    # to store the CNAMEs used to delegate a suboctet zone
+    # $suboct{zone}{ns}[] -> array of nameservers
+    # $suboct{zone}{cname}[] -> array of extant CNAMEs (Just In Case someone did something bizarre)
+## commented pending actual use of this data.  for now, we'll just
+## auto-(re)create the CNAMEs in revzones on export
+#    my %suboct;
+
     while (my $rr = $res->axfr_next()) {
+
+      my $val;
+      my $distance = 0;
+      my $weight = 0;
+      my $port = 0;
+      my $logfrag = '';
+
       my $type = $rr->type;
       my $ttl = ($newttl ? $newttl : $rr->ttl);	# allow force-override TTLs
-
-      my $sql = "INSERT INTO records (domain_id,host,type,ttl,val";
-      my $vallen = "?,?,?,?,?";
+      my $host = $rr->name;
 
       $soaflag = 1 if $type eq 'SOA';
       $nsflag = 1 if $type eq 'NS';
-
-      my @vallist = ($dom_id, $rr->name, $reverse_typemap{$type}, $ttl);
 
 # "Primary" types:
@@ -2636,4 +4292,16 @@
 # maybe KEY
 
+# BIND supports:
+# [standard]
+# A AAAA CNAME MX NS PTR SOA TXT
+# [variously experimental, obsolete, or obscure]
+# HINFO MB(ex) MD(ob) MF(ob) MG(ex) MINFO(ex) MR(ex) NULL WKS AFSDB(ex) ISDN(ex) RP(ex) RT(ex) X25(ex) PX
+# ... if one can ever find the right magic to format them correctly
+
+# Net::DNS supports:
+# RRSIG SIG NSAP NS NIMLOC NAPTR MX MR MINFO MG MB LOC ISDN IPSECKEY HINFO
+# EID DNAME CNAME CERT APL AFSDB AAAA A DS NXT NSEC3PARAM NSEC3 NSEC KEY
+# DNSKEY DLV X25 TXT TSIG TKEY SSHFP SRV SPF SOA RT RP PX PTR NULL APL::AplItem
+
 # nasty big ugly case-like thing here, since we have to do *some* different
 # processing depending on the record.  le sigh.
@@ -2642,49 +4310,84 @@
 
       if ($type eq 'A') {
-	push @vallist, $rr->address;
+	$val = $rr->address;
       } elsif ($type eq 'NS') {
 # hmm.  should we warn here if subdomain NS'es are left alone?
-	next if ($rwns && ($rr->name eq $domain));
-	push @vallist, $rr->nsdname;
+	next if ($rwns && ($rr->name eq $zone));
+	if ($rev eq 'y') {
+	  # revzones have records more or less reversed from forward zones.
+	  my ($tmpcode,$tmpmsg) = _zone2cidr($host);
+	  die "Error converting NS record: $tmpmsg\n" if $tmpcode eq 'FAIL';	# hmm.  may not make sense...
+	  $val = "$tmpmsg";
+	  $host = $rr->nsdname;
+	  $logfrag = "Added record '$val $type $host', TTL $ttl";
+# Tag and preserve.  For now this is commented for a no-op, but we have Ideas for
+# another custom storage type ("DELEGATE") that will use these subzone-delegation records
+#if ($val ne "$cidr") {
+#  push @{$suboct{$val}{ns}}, $host;
+#}
+	} else {
+	  $val = $rr->nsdname;
+	}
 	$nsflag = 1;
       } elsif ($type eq 'CNAME') {
-	push @vallist, $rr->cname;
+	if ($rev eq 'y') {
+	  # hmm.  do we even want to bother with storing these at this level?  Sub-octet delegation
+	  # by CNAME is essentially a record-publication hack, and we want to just represent the
+	  # "true" logical intentions as far down the stack as we can from the UI.
+	  ($host,$val) = _revswap($host,$rr->cname);
+	  $logfrag = "Added record '$val $type $host', TTL $ttl";
+# Tag and preserve in case we want to commit them as-is later, but mostly we don't care.
+# Commented pending actually doing something with possibly new type DELEGATE
+#my $tmprev = $host;
+#$tmprev =~ s/^\d+\.//;
+#($code,$tmprev) = _zone2cidr($tmprev);
+#push @{$suboct{"$tmprev"}{cname}}, $val;
+	  # Silently skip CNAMEs in revzones.
+	  next;
+	} else {
+	  $val = $rr->cname;
+	}
       } elsif ($type eq 'SOA') {
 	next if $rwsoa;
-	$vallist[1] = $rr->mname.":".$rr->rname;
-	push @vallist, ($rr->refresh.":".$rr->retry.":".$rr->expire.":".$rr->minimum);
+	$host = $rr->rname.":".$rr->mname;
+	$val = $rr->refresh.":".$rr->retry.":".$rr->expire.":".$rr->minimum;
 	$soaflag = 1;
       } elsif ($type eq 'PTR') {
-	push @vallist, $rr->ptrdname;
+	($host,$val) = _revswap($host,$rr->ptrdname);
+	$logfrag = "Added record '$val $type $host', TTL $ttl";
 	# hmm.  PTR records should not be in forward zones.
       } elsif ($type eq 'MX') {
-	$sql .= ",distance";
-	$vallen .= ",?";
-	push @vallist, $rr->exchange;
-	push @vallist, $rr->preference;
+	$val = $rr->exchange;
+	$distance = $rr->preference;
       } elsif ($type eq 'TXT') {
 ##fixme:  Net::DNS docs say this should be deprecated for rdatastr() or char_str_list(),
 ## but don't really seem enthusiastic about it.
-	my $rrdata = $rr->txtdata;
-	push @vallist, $rrdata;
+#print "should use rdatastr:\n\t".$rr->rdatastr."\n  or char_str_list:\n\t".join(' ',$rr->char_str_list())."\n";
+# rdatastr returns a BIND-targetted logical string, including opening and closing quotes
+# char_str_list returns a list of the individual string fragments in the record
+# txtdata returns the more useful all-in-one form (since we want to push such protocol
+# details as far down the stack as we can)
+# NB:  this may turn out to be more troublesome if we ever have need of >512-byte TXT records.
+	if ($rev eq 'y') {
+	  ($host,$val) = _revswap($host,$rr->txtdata);
+          $logfrag = "Added record '$val $type $host', TTL $ttl";
+	} else {
+	  $val = $rr->txtdata;
+	}
       } elsif ($type eq 'SPF') {
 ##fixme: and the same caveat here, since it is apparently a clone of ::TXT
-	my $rrdata = $rr->txtdata;
-	push @vallist, $rrdata;
+	$val = $rr->txtdata;
       } elsif ($type eq 'AAAA') {
-	push @vallist, $rr->address;
+	$val = $rr->address;
       } elsif ($type eq 'SRV') {
-	$sql .= ",distance,weight,port" if $type eq 'SRV';
-	$vallen .= ",?,?,?" if $type eq 'SRV';
-	push @vallist, $rr->target;
-	push @vallist, $rr->priority;
-	push @vallist, $rr->weight;
-	push @vallist, $rr->port;
+	$val = $rr->target;
+	$distance = $rr->priority;
+	$weight = $rr->weight;
+	$port = $rr->port;
       } elsif ($type eq 'KEY') {
 	# we don't actually know what to do with these...
-	push @vallist, ($rr->flags.":".$rr->protocol.":".$rr->algorithm.":".$rr->key.":".$rr->keytag.":".$rr->privatekeyname);
+	$val = $rr->flags.":".$rr->protocol.":".$rr->algorithm.":".$rr->key.":".$rr->keytag.":".$rr->privatekeyname;
       } else {
-	my $rrdata = $rr->rdatastr;
-	push @vallist, $rrdata;
+	$val = $rr->rdatastr;
 	# Finding a different record type is not fatal.... just problematic.
 	# We may not be able to export it correctly.
@@ -2692,20 +4395,85 @@
       }
 
-# BIND supports:
-# A CNAME HINFO MB(ex) MD(ob) MF(ob) MG(ex) MINFO(ex) MR(ex) MX NS NULL
-# PTR SOA TXT WKS AFSDB(ex) ISDN(ex) RP(ex) RT(ex) X25(ex) PX
-# ... if one can ever find the right magic to format them correctly
-
-# Net::DNS supports:
-# RRSIG SIG NSAP NS NIMLOC NAPTR MX MR MINFO MG MB LOC ISDN IPSECKEY HINFO
-# EID DNAME CNAME CERT APL AFSDB AAAA A DS NXT NSEC3PARAM NSEC3 NSEC KEY
-# DNSKEY DLV X25 TXT TSIG TKEY SSHFP SRV SPF SOA RT RP PX PTR NULL APL::AplItem
-
-      $sth = $dbh->prepare($sql.") VALUES (".$vallen.")") or die "problem preparing record insert SQL\n";
-      $sth->execute(@vallist) or die "failed to insert ".$rr->string.": ".$sth->errstr."\n";
+      my $logentry = "[AXFR ".($rev eq 'n' ? $zone : $cidr)."] ";
+
+      if ($merge) {
+	if ($rev eq 'n') {
+	  # importing a domain;  we have A and AAAA records that could be merged with matching PTR records
+	  my $etype;
+	  my ($erdns,$erid,$ettl) = $dbh->selectrow_array("SELECT rdns_id,record_id,ttl FROM records ".
+		"WHERE host=? AND val=? AND type=12",
+		undef, ($host, $val) );
+	  if ($erid) {
+	    if ($type eq 'A') {	# PTR -> A+PTR
+	      $etype = 65280;
+	      $logentry .= "Merged A record with existing PTR record '$host A+PTR $val', TTL $ettl";
+	    }
+	    if ($type eq 'AAAA') {	# PTR -> AAAA+PTR
+	      $etype = 65281;
+	      $logentry .= "Merged AAAA record with existing PTR record '$host AAAA+PTR $val', TTL $ettl";
+	    }
+	    $ettl = ($ettl < $ttl ? $ettl : $ttl);    # use lower TTL
+	    $dbh->do("UPDATE records SET domain_id=?,ttl=?,type=? WHERE record_id=?", undef,
+		($domain_id, $ettl, $etype, $erid));
+	    $nrecs++;
+	    _log($dbh, (group_id => $group, domain_id => $domain_id, rdns_id => $erdns, entry => $logentry) );
+	    next;	# while axfr_next
+	  }
+	} # $rev eq 'n'
+	else {
+	  # importing a revzone, we have PTR records that could be merged with matching A/AAAA records
+	  my ($domid,$erid,$ettl,$etype) = $dbh->selectrow_array("SELECT domain_id,record_id,ttl,type FROM records ".
+		"WHERE host=? AND val=? AND (type=1 OR type=28)",
+		undef, ($host, $val) );
+	  if ($erid) {
+	    if ($etype == 1) {	# A -> A+PTR
+	      $etype = 65280;
+	      $logentry .= "Merged PTR record with existing matching A record '$host A+PTR $val', TTL $ettl";
+	    }
+	    if ($etype == 28) {	# AAAA -> AAAA+PTR
+	      $etype = 65281;
+	      $logentry .= "Merged PTR record with existing matching AAAA record '$host AAAA+PTR $val', TTL $ettl";
+	    }
+	    $ettl = ($ettl < $ttl ? $ettl : $ttl);    # use lower TTL
+	    $dbh->do("UPDATE records SET rdns_id=?,ttl=?,type=? WHERE record_id=?", undef,
+		($rdns_id, $ettl, $etype, $erid));
+	    $nrecs++;
+	    _log($dbh, (group_id => $group, domain_id => $domid, rdns_id => $rdns_id, entry => $logentry) );
+	    next;	# while axfr_next
+	  }
+	} # $rev eq 'y'
+      } # if $merge
+
+      # Insert the new record
+      $sth->execute($domain_id, $rdns_id, $host, $reverse_typemap{$type}, $val,
+	$distance, $weight, $port, $ttl);
 
       $nrecs++;
 
+      if ($type eq 'SOA') {
+	# also !$rwsoa, but if that's set, it should be impossible to get here.
+	my @tmp1 = split /:/, $host;
+	my @tmp2 = split /:/, $val;
+	$logentry .= "Added SOA record [contact $tmp1[0]] [master $tmp1[1]] ".
+		"[refresh $tmp2[0]] [retry $tmp2[1]] [expire $tmp2[2]] [minttl $tmp2[3]], TTL $ttl";
+      } elsif ($logfrag) {
+	# special case for log entries we need to meddle with a little.
+	$logentry .= $logfrag;
+      } else {
+	$logentry .= "Added record '$host $type";
+	$logentry .= " [distance $distance]" if $type eq 'MX';
+	$logentry .= " [priority $distance] [weight $weight] [port $port]" if $type eq 'SRV';
+	$logentry .= " $val', TTL $ttl";
+      }
+      _log($dbh, (group_id => $group, domain_id => $domain_id, rdns_id => $rdns_id, entry => $logentry) );
+
     } # while axfr_next
+
+# Detect and handle delegated subzones
+# Placeholder for when we decide what to actually do with this, see previous comments in NS and CNAME handling.
+#foreach (keys %suboct) {
+#  print "found ".($suboct{$_}{ns} ? @{$suboct{$_}{ns}} : '0')." NS records and ".
+#	($suboct{$_}{cname} ? @{$suboct{$_}{cname}} : '0')." CNAMEs for $_\n";
+#}
 
     # Overwrite SOA record
@@ -2716,7 +4484,7 @@
       $sthgetsoa->execute($group,$reverse_typemap{SOA});
       while (my ($host,$val,$ttl) = $sthgetsoa->fetchrow_array()) {
-	$host =~ s/DOMAIN/$domain/g;
-	$val =~ s/DOMAIN/$domain/g;
-	$sthputsoa->execute($dom_id,$host,$reverse_typemap{SOA},$val,$ttl);
+	$host =~ s/DOMAIN/$zone/g;
+	$val =~ s/DOMAIN/$zone/g;
+	$sthputsoa->execute($zone_id,$host,$reverse_typemap{SOA},$val,$ttl);
       }
     }
@@ -2729,7 +4497,7 @@
       $sthgetns->execute($group,$reverse_typemap{NS});
       while (my ($host,$val,$ttl) = $sthgetns->fetchrow_array()) {
-	$host =~ s/DOMAIN/$domain/g;
-	$val =~ s/DOMAIN/$domain/g;
-	$sthputns->execute($dom_id,$host,$reverse_typemap{NS},$val,$ttl);
+	$host =~ s/DOMAIN/$zone/g;
+	$val =~ s/DOMAIN/$zone/g;
+	$sthputns->execute($zone_id,$host,$reverse_typemap{NS},$val,$ttl);
       }
     }
@@ -2757,4 +4525,14 @@
 
 
+## DNSDB::importBIND()
+sub importBIND {
+} # end importBIND()
+
+
+## DNSDB::import_tinydns()
+sub import_tinydns {
+} # end import_tinydns()
+
+
 ## DNSDB::export()
 # Export the DNS database, or a part of it
@@ -2785,4 +4563,164 @@
 
 ##fixme: slurp up further options to specify particular zone(s) to export
+
+##fixme: fail if $datafile isn't an open, writable file
+
+  # easy case - export all evarything
+  # not-so-easy case - export item(s) specified
+  # todo:  figure out what kind of list we use to export items
+
+# raw packet in unknown format:  first byte indicates length
+# of remaining data, allows up to 255 raw bytes
+
+  # Locations/views - worth including in the caching setup?
+  my $lochash = $dbh->selectall_hashref("SELECT location,iplist FROM locations", 'location');
+  foreach my $location (keys %$lochash) {
+    foreach my $ipprefix (split /[,\s]+/, $lochash->{$location}{iplist}) {
+      $ipprefix =~ s/\s+//g;
+      print $datafile "%$location:$ipprefix\n";
+    }
+    print $datafile "%$location\n" if !$lochash->{$location}{iplist};
+  }
+
+  # tracking hash so we don't double-export A+PTR or AAAA+PTR records.
+  my %recflags;
+
+  my $domsth = $dbh->prepare("SELECT domain_id,domain,status,changed FROM domains WHERE status=1");
+  my $recsth = $dbh->prepare("SELECT host,type,val,distance,weight,port,ttl,record_id,location ".
+	"FROM records WHERE domain_id=? AND type < 65280");	# Just exclude all types relating to rDNS
+  my $zonesth = $dbh->prepare("UPDATE domains SET changed='n' WHERE domain_id=?");
+  $domsth->execute();
+  while (my ($domid,$dom,$domstat,$changed) = $domsth->fetchrow_array) {
+##fixme: need to find a way to block opening symlinked files without introducing a race.
+#       O_NOFOLLOW
+#              If  pathname  is a symbolic link, then the open fails.  This is a FreeBSD extension, which was
+#              added to Linux in version 2.1.126.  Symbolic links in earlier components of the pathname  will
+#              still be followed.
+# but that doesn't help other platforms.  :/
+    sysopen(ZONECACHE, "$config{exportcache}/$dom", O_RDWR|O_CREAT);
+    flock(ZONECACHE, LOCK_EX);
+    if ($changed || -s "$config{exportcache}/$dom" == 0) {
+      $recsth->execute($domid);
+      while (my ($host,$type,$val,$dist,$weight,$port,$ttl,$recid,$loc) = $recsth->fetchrow_array) {
+	next if $recflags{$recid};
+
+	$loc = '' if !$loc;	# de-nullify - just in case
+##fixme:  handle case of record-with-location-that-doesn't-exist better.
+# note this currently fails safe (tested) - records with a location that
+# doesn't exist will not be sent to any client
+#	$loc = '' if !$lochash->{$loc};
+
+##fixme:  record validity timestamp. tinydns supports fiddling with timestamps.
+# note $ttl must be set to 0 if we want to use tinydns's auto-expiring timestamps.
+# timestamps are TAI64
+# ~~ 2^62 + time()
+	my $stamp = '';
+
+	# support tinydns' auto-TTL
+	$ttl = '' if $ttl == '0';
+
+	_printrec_tiny($datafile, 'n', \%recflags,
+		$dom, $host, $type, $val, $dist, $weight, $port, $ttl, $loc, $stamp);
+
+	_printrec_tiny(*ZONECACHE, 'n', \%recflags,
+		$dom, $host, $type, $val, $dist, $weight, $port, $ttl, $loc, $stamp)
+		if *ZONECACHE;
+	# in case the zone shrunk, get rid of garbage at the end of the file.
+	truncate(ZONECACHE, tell(ZONECACHE));
+
+	$recflags{$recid} = 1;
+      } # while ($recsth)
+    } else {
+      # domain not changed, stream from cache
+      print $datafile $_ while <ZONECACHE>;
+    }
+    close ZONECACHE;
+    # mark domain as unmodified
+    $zonesth->execute($domid);
+  } # while ($domsth)
+
+  my $revsth = $dbh->prepare("SELECT rdns_id,revnet,status,changed FROM revzones WHERE status=1 ".
+	"ORDER BY masklen(revnet) DESC");
+
+# For reasons unknown, we can't sanely UNION these statements.  Feh.
+# Supposedly it should work though (note last 3 lines):
+## PG manual
+#UNION Clause
+#
+#The UNION clause has this general form:
+#
+#    select_statement UNION [ ALL ] select_statement
+#
+#select_statement is any SELECT statement without an ORDER BY, LIMIT, FOR UPDATE, or FOR SHARE clause. (ORDER BY
+#and LIMIT can be attached to a subexpression if it is enclosed in parentheses. Without parentheses, these
+#clauses will be taken to apply to the result of the UNION, not to its right-hand input expression.)
+  my $soasth = $dbh->prepare("SELECT host,type,val,distance,weight,port,ttl,record_id,location ".
+	"FROM records WHERE rdns_id=? AND type=6");
+  $recsth = $dbh->prepare("SELECT host,type,val,distance,weight,port,ttl,record_id,location ".
+	"FROM records WHERE rdns_id=? AND not type=6 ".
+	"ORDER BY masklen(CAST(val AS inet)) DESC, CAST(val AS inet)");
+  $zonesth = $dbh->prepare("UPDATE revzones SET changed='n' WHERE rdns_id=?");
+  $revsth->execute();
+  while (my ($revid,$revzone,$revstat,$changed) = $revsth->fetchrow_array) {
+##fixme: need to find a way to block opening symlinked files without introducing a race.
+#       O_NOFOLLOW
+#              If  pathname  is a symbolic link, then the open fails.  This is a FreeBSD extension, which was
+#              added to Linux in version 2.1.126.  Symbolic links in earlier components of the pathname  will
+#              still be followed.
+# but that doesn't help other platforms.  :/
+    my $tmpzone = NetAddr::IP->new($revzone);
+    sysopen(ZONECACHE, "$config{exportcache}/".$tmpzone->network->addr, O_RDWR|O_CREAT);
+    flock(ZONECACHE, LOCK_EX);
+    if ($changed || -s "$config{exportcache}/".$tmpzone->network->addr == 0) {
+      # need to fetch this separately since the rest of the records all (should) have real IPs in val
+      $soasth->execute($revid);
+      my (@zsoa) = $soasth->fetchrow_array();
+      _printrec_tiny($datafile,'y',\%recflags,$revzone,
+	$zsoa[0],$zsoa[1],$zsoa[2],$zsoa[3],$zsoa[4],$zsoa[5],$zsoa[6],$zsoa[8],'');
+
+      $recsth->execute($revid);
+      while (my ($host,$type,$val,$dist,$weight,$port,$ttl,$recid,$loc) = $recsth->fetchrow_array) {
+	next if $recflags{$recid};
+
+	$loc = '' if !$loc;	# de-nullify - just in case
+##fixme:  handle case of record-with-location-that-doesn't-exist better.
+# note this currently fails safe (tested) - records with a location that
+# doesn't exist will not be sent to any client
+#	$loc = '' if !$lochash->{$loc};
+
+##fixme:  record validity timestamp. tinydns supports fiddling with timestamps.
+# note $ttl must be set to 0 if we want to use tinydns's auto-expiring timestamps.
+# timestamps are TAI64
+# ~~ 2^62 + time()
+	my $stamp = '';
+
+	# support tinydns' auto-TTL
+	$ttl = '' if $ttl == '0';
+
+	_printrec_tiny($datafile, 'y', \%recflags, $revzone,
+		$host, $type, $val, $dist, $weight, $port, $ttl, $loc, $stamp);
+	_printrec_tiny(*ZONECACHE, 'y', \%recflags, $revzone,
+		$host, $type, $val, $dist, $weight, $port, $ttl, $loc, $stamp)
+		if *ZONECACHE;
+	# in case the zone shrunk, get rid of garbage at the end of the file.
+	truncate(ZONECACHE, tell(ZONECACHE));
+
+	$recflags{$recid} = 1;
+      } # while ($recsth)
+    } else {
+      # zone not changed, stream from cache
+      print $datafile $_ while <ZONECACHE>;
+    }
+    close ZONECACHE;
+    # mark domain as unmodified
+    $zonesth->execute($revid);
+  } # while ($domsth)
+
+} # end __export_tiny()
+
+
+# Utility sub for __export_tiny above
+sub _printrec_tiny {
+  my ($datafile,$revrec,$recflags,$zone,$host,$type,$val,$dist,$weight,$port,$ttl,$loc,$stamp) = @_;
 
   ## Convert a bare number into an octal-coded pair of octets.
@@ -2797,38 +4735,34 @@
   }
 
-##fixme: fail if $datafile isn't an open, writable file
-
-  # easy case - export all evarything
-  # not-so-easy case - export item(s) specified
-  # todo:  figure out what kind of list we use to export items
-
-  my $domsth = $dbh->prepare("SELECT domain_id,domain,status FROM domains WHERE status=1");
-  my $recsth = $dbh->prepare("SELECT host,type,val,distance,weight,port,ttl ".
-	"FROM records WHERE domain_id=?");
-  $domsth->execute();
-  while (my ($domid,$dom,$domstat) = $domsth->fetchrow_array) {
-    $recsth->execute($domid);
-    while (my ($host,$type,$val,$dist,$weight,$port,$ttl) = $recsth->fetchrow_array) {
-##fixme:  need to store location in the db, and retrieve it here.
-# temporarily hardcoded to empty so we can include it further down.
-my $loc = '';
-
-##fixme:  record validity timestamp. tinydns supports fiddling with timestamps.
-# note $ttl must be set to 0 if we want to use tinydns's auto-expiring timestamps.
-# timestamps are TAI64
-# ~~ 2^62 + time()
-my $stamp = '';
-
-# raw packet in unknown format:  first byte indicates length
-# of remaining data, allows up to 255 raw bytes
-
-	# Spaces are evil.
-	$host =~ s/^\s+//;
-	$host =~ s/\s+$//;
-	if ($typemap{$type} ne 'TXT') {
-	  # Leading or trailng spaces could be legit in TXT records.
-	  $val =~ s/^\s+//;
-	  $val =~ s/\s+$//;
-	}
+## WARNING:  This works to export even the whole Internet's worth of IP space...
+##  if you have the disk/RAM to handle the dataset, and you call this sub based on /16-sized chunks
+##  A /16 took ~3 seconds with a handful of separate records;  adding a /8 pushed export time out to ~13m:40s 
+##  0/0 is estimated to take ~54 hours and ~256G of disk
+##  RAM usage depends on how many non-template entries you have in the set.
+##  This should probably be done on record addition rather than export;  large blocks may need to be done in a
+##  forked process
+  sub __publish_subnet {
+    my $sub = shift;
+    my $recflags = shift;
+    my $hpat = shift;
+    my $fh = shift;
+    my $ttl = shift;
+    my $stamp = shift;
+    my $loc = shift;
+    my $ptronly = shift || 0;
+
+    my $iplist = $sub->splitref(32);
+    foreach (@$iplist) {
+      my $ip = $_->addr;
+      # make as if we split the non-octet-aligned block into octet-aligned blocks as with SOA
+      next if $ip =~ /\.(0|255)$/;
+      next if $$recflags{$ip};
+      $$recflags{$ip}++;
+      my $rec = $hpat;	# start fresh with the template for each IP
+      _template4_expand(\$rec, $ip);
+      print $fh ($ptronly ? "^"._ZONE($_, 'ZONE.in-addr.arpa', 'r', '.').":$rec" : "=$rec:$ip").
+	":$ttl:$stamp:$loc\n";
+    }
+  }
 
 ##fixme?  append . to all host/val hostnames
@@ -2841,5 +4775,20 @@
 	my ($email, $primary) = (split /:/, $host)[0,1];
 	my ($refresh, $retry, $expire, $min_ttl) = (split /:/, $val)[0,1,2,3];
-	print $datafile "Z$dom:$primary:$email"."::$refresh:$retry:$expire:$min_ttl:$ttl:$stamp:$loc\n";
+	if ($revrec eq 'y') {
+##fixme:  have to publish SOA records for each v4 /24 in sub-/16, and each /16 in sub-/8
+# what about v6?
+# -> only need SOA for local chunks offset from reverse delegation boundaries, so v6 is fine
+	  $zone = NetAddr::IP->new($zone);
+	  # handle split-n-multiply SOA for off-octet (8 < mask < 16) or (16 < mask < 24) v4 zones
+	  if (!$zone->{isv6} && ($zone->masklen < 24) && ($zone->masklen % 8 != 0)) {
+	    foreach my $szone ($zone->split($zone->masklen + (8 - $zone->masklen % 8))) {
+	      $szone = _ZONE($szone, 'ZONE.in-addr.arpa', 'r', '.');
+	      print $datafile "Z$szone:$primary:$email"."::$refresh:$retry:$expire:$min_ttl:$ttl:$stamp:$loc\n";
+	    }
+	    return; # skips "default" bits just below
+	  }
+	  $zone = _ZONE($zone, 'ZONE', 'r', '.').($zone->{isv6} ? '.ip6.arpa' : '.in-addr.arpa');
+	}
+	print $datafile "Z$zone:$primary:$email"."::$refresh:$retry:$expire:$min_ttl:$ttl:$stamp:$loc\n";
 
       } elsif ($typemap{$type} eq 'A') {
